# TODO: Support additional selinux types
%global selinux_variants targeted
%{!?_selinux_policy_version: %global _selinux_policy_version %(%{__sed} -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' /usr/share/selinux/devel/policyhelp 2>/dev/null)}
%global modulename tower

%global tower_version 3.4.1
%global tower_release 2
%global sdist_tar_name ansible-tower-3.4.1

%global distro_python_sitelib %(/usr/bin/python -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")

# Remove brp-python-bytecompile from os_install_post
%global __os_install_post /usr/lib/rpm/redhat/brp-compress \
  %{!?__debug_package:/usr/lib/rpm/redhat/brp-strip %{__strip}} \
  /usr/lib/rpm/redhat/brp-strip-static-archive %{__strip} \
  /usr/lib/rpm/redhat/brp-strip-comment-note %{__strip} %{__objdump} \
  /usr/lib/rpm/redhat/brp-python-hardlink

# Bytecompile using the correct interpreter, and then
# remove tower python source files
%define __spec_install_post \
 %{__arch_install_post} \
 %{__os_install_post} \
 echo "Bytecompiling Tower itself (errors will fail) ..." \
 %{_sourcedir}/bytecompile.sh %{buildroot}/var/lib/awx/venv/awx/lib/python2.7/site-packages/awx/ \
 echo "Bytecompiling Tower site-packages (errors ignored) ..." \
 %{_sourcedir}/bytecompile.sh --no-fail-on-errors %{buildroot}/var/lib/awx/venv/awx/ \
 echo "Bytecompiling Ansible site-packages (errors ignored) ..." \
 %{_sourcedir}/bytecompile.sh --no-fail-on-errors %{buildroot}/var/lib/awx/venv/ansible/ \
 echo "Removing ansible-tower python source files ..." \
 %{__python} %{_sourcedir}/remove_tower_source.py %{buildroot}/%{python_sitelib} %{buildroot}/var/lib/awx/venv/awx/lib/python2.7/site-packages \
%{nil}

# Don't break the RPM build on pycompile errors
%define _python_bytecompile_errors_terminate_build 0

Name: ansible-tower
Summary: REST api, server, plugins, UI, & CLI client for ansible
Version: %{tower_version}
Release: %{tower_release}%{?dist}
Source0: https://github.com/ansible/%{name}/archive/%{version}.tar.gz?/%{sdist_tar_name}.tar.gz
Source1: %{modulename}.te
Source2: remove_tower_source.py
Source3: %{name}.sysconfig
Source4: bytecompile.sh
Source5: %{modulename}.fc
Source6: %{name}-setup-%{version}-2.tar.gz
Source7: tower-license-0.1-%{tower_release}.tar.gz
%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
Source8: ansible-tower-3.4.1-python-deps.tar.gz
%endif
Provides: awx = %{version}-%{release}
Obsoletes: awx < 1.4.5-0

Group: Development/Libraries
License: Commercial, see https://www.redhat.com/en/about/red-hat-end-user-license-agreements and https://www.redhat.com/en/about/licenses
Url: http://ansible.github.com

# Build Requirements
BuildArch: x86_64
BuildRequires: python-devel
BuildRequires: python-setuptools
BuildRequires: python2-pip
BuildRequires: python-virtualenv
BuildRequires: checkpolicy
BuildRequires: selinux-policy-devel
BuildRequires: /usr/share/selinux/devel/policyhelp
BuildRequires: hardlink
BuildRequires: sed
# BuildRequires: npm
# BuildRequires: nodejs-grunt-cli
# The following are needed for python vendoring
BuildRequires: git
BuildRequires: make
BuildRequires: gcc
BuildRequires: bzip2
BuildRequires: postgresql-devel
BuildRequires: libffi-devel
BuildRequires: openssl-devel
BuildRequires: openldap-devel
BuildRequires: libxml2-devel
BuildRequires: libxslt-devel
BuildRequires: xmlsec1-devel, xmlsec1-openssl-devel
BuildRequires: libtool-ltdl-devel
BuildRequires: swig
BuildRequires: python-pycurl
BuildRequires: libcurl-devel

Requires: ansible-tower-server = %{version}-%{release}
Requires: ansible-tower-ui = %{version}-%{release}

%description
REST api, server, plugins, Web UI, & CLI client for ansible.

%package server
Summary: Ansible Tower REST API
Requires: ansible-tower-venv-ansible = %{version}-%{release}
Requires: ansible-tower-venv-tower = %{version}-%{release}
Requires: nginx
Requires: ansible
Requires: sshpass
Requires: postgresql96
Requires: supervisor >= 3.0
Requires: bubblewrap >= 0.1.2
Requires: git
Requires: subversion
Requires: mercurial
Requires: sos
Requires: rsync
Requires: rsyslog
Requires: xmlsec1
Requires: xmlsec1-openssl
Requires: memcached
Requires: rabbitmq-server
Requires: python-crypto
# SELinux requirements
%if "%{_selinux_policy_version}" != ""
Conflicts: selinux-policy < 3.13.1-60.el7
# for seboolean Ansible module
Requires: libsemanage-python
%endif
Requires(post): policycoreutils
Requires(post): libselinux-utils
Requires(postun): policycoreutils

%description server
Ansible Tower Server and REST API

%package ui
Summary: Ansible Tower UI
Requires: ansible-tower-server = %{version}-%{release}

%description ui
UI for Ansible Tower

%package setup
Summary: Installer for Ansible Tower

%description setup
Installer for Ansible Tower

%package venv-ansible
Summary: Ansible virtual environment
AutoReqProv: no
Requires(pre): python
Requires(pre): python-virtualenv

%description venv-ansible
Ansible virtual environment

%package venv-tower
Summary: Tower virtual environment
AutoReqProv: no
Requires(pre): python
Requires(pre): python-virtualenv

%description venv-tower
Tower virtual environment

%prep
%setup -q -n %{sdist_tar_name}

tar -xf %{SOURCE6}

mkdir SELinux
cp -p %{SOURCE1} %{SOURCE5} SELinux/

%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
tar -xf %{SOURCE8}
%endif


%build
# Disable debuginfo packages
%define _enable_debug_package 0
%define debug_package %{nil}


%install

mkdir -p %{buildroot}/var/lib/awx
mv %{name}-setup-%{version}-2/ %{buildroot}/var/lib/awx/setup

# Create folder for the virtualenvs
export VENV_BASE=venv
mkdir -p $VENV_BASE

# Fix m2crypto builds (details at http://pkgs.fedoraproject.org/cgit/m2crypto.git/tree/m2crypto.spec)
export SWIG_FEATURES="-cpperraswarn"

%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
export PIP_OPTIONS="--find-links=tower/requirements/vendor --no-index"

cat >> setup.cfg <<EOF
[easy_install]
allow_hosts = ''
find_links = file://$PWD/tower/requirements/vendor/
EOF

cp setup.cfg ~/.pydistutils.cfg
%endif

# Install the Ansible venv and requirements
%{__make} requirements_ansible

export CFLAGS="-DXMLSEC_NO_SIZE_T"
# Install the Tower venv and requirements
%{__make} requirements_awx

# Build to the dist folder
python setup.py build

# Build SELinux policy package (.pp)
pushd SELinux
for selinuxvariant in %{selinux_variants}; do
    make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile
    mv %{modulename}.pp %{modulename}.pp.${selinuxvariant}
    make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile clean
done
popd

# Install the tower-license package into the tower venv
$VENV_BASE/awx/bin/pip install %{SOURCE7}

# Move site-packages to the buildroot
PYTHON_VER=$(basename $(ls -d venv/ansible/lib/python* | head --lines 1))
mkdir -p %{buildroot}/var/lib/awx/venv/ansible/lib/${PYTHON_VER}
mv venv/ansible/lib/${PYTHON_VER}/site-packages %{buildroot}/var/lib/awx/venv/ansible/lib/${PYTHON_VER}/site-packages

mkdir -p %{buildroot}/var/lib/awx/venv/awx/lib/python2.7
mv venv/awx/lib/python2.7/site-packages %{buildroot}/var/lib/awx/venv/awx/lib/python2.7/site-packages
mkdir -p %{buildroot}/var/lib/awx/venv/awx/bin
mv venv/awx/bin/uwsgi %{buildroot}/var/lib/awx/venv/awx/bin/uwsgi
mv venv/awx/bin/daphne %{buildroot}/var/lib/awx/venv/awx/bin/daphne

PYTHON_INTERPRETER='#!/var/lib/awx/venv/awx/bin/python'
sed -i "1 s|^.*$|$PYTHON_INTERPRETER|" %{buildroot}/var/lib/awx/venv/awx/bin/daphne

# Install to the buildroot (non virtualenv)
mkdir -p %{buildroot}/rpm-tmp
python setup.py install --skip-build --no-compile --root=%{buildroot}/rpm-tmp

# Move files from rpm-tmp folder to the appropriate base folders
mv %{buildroot}/rpm-tmp/usr/lib/python2.7/site-packages/* %{buildroot}/var/lib/awx/venv/awx/lib/python2.7/site-packages

mkdir -p %{buildroot}/usr/bin
mv %{buildroot}/rpm-tmp/usr/bin/* %{buildroot}/usr/bin

# Symlinks to old tower-python and tower-manage executables
ln -s %{_bindir}/awx-manage %{buildroot}/%{_bindir}/tower-manage
ln -s %{_bindir}/awx-python %{buildroot}/%{_bindir}/tower-python

mkdir -p %{buildroot}/usr/share/sosreport/sos/plugins
mv %{buildroot}/rpm-tmp/usr/share/sosreport/sos/plugins/* %{buildroot}/usr/share/sosreport/sos/plugins

mkdir -p %{buildroot}/usr/share/doc/ansible-tower
mv %{buildroot}/rpm-tmp/usr/share/doc/awx/* %{buildroot}/usr/share/doc/ansible-tower

mkdir -p %{buildroot}/usr/share/awx
mv %{buildroot}/rpm-tmp/usr/share/awx/* %{buildroot}/usr/share/awx

mkdir -p %{buildroot}/var/lib/awx
mv %{buildroot}/rpm-tmp/var/lib/awx/* %{buildroot}/var/lib/awx

rm -rf %{buildroot}/rpm-tmp

# Create other needed folders
install -d %{buildroot}/%{_sysconfdir}/tower/
install -d %{buildroot}/%{_sysconfdir}/sysconfig/
install -d -m 0750 %{buildroot}/var/log/tower
install -d -m 0750 %{buildroot}/var/lib/awx/job_status
install -d %{buildroot}/%{_datadir}/awx
install -d -m 0750 %{buildroot}/var/run/memcached

# SELinux setup
install -p -m644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/sysconfig/%{name}
for selinuxvariant in %{selinux_variants}
do
  install -d %{buildroot}%{_datadir}/selinux/${selinuxvariant}
  install -p -m 644 SELinux/%{modulename}.pp.${selinuxvariant} \
    %{buildroot}%{_datadir}/selinux/${selinuxvariant}/%{modulename}.pp
done
/usr/sbin/hardlink -cv %{buildroot}%{_datadir}/selinux

%clean
rm -rf %{buildroot}

%preun
ansible-tower-service stop

%pre server
getent group awx >/dev/null || groupadd -r awx
getent passwd awx >/dev/null || \
    useradd -r -g awx -d /var/lib/awx -s /bin/bash awx

%post server
# Generate or reuse key file
if [ ! -f /etc/tower/SECRET_KEY ]; then
    /usr/bin/python -c "import uuid; file('/etc/tower/SECRET_KEY', 'wb').write(uuid.uuid4().hex)"
fi
chown root:awx /etc/tower/SECRET_KEY
chmod 640 /etc/tower/SECRET_KEY

# Create sosreport symlinks
ln -s ../../../../../share/sosreport/sos/plugins/tower.py  %{distro_python_sitelib}/sos/plugins/ || :

# allow needed httpd access
for selinuxvariant in %{selinux_variants} ; do
    semodule -s ${selinuxvariant} -i %{_datadir}/selinux/${selinuxvariant}/%{modulename}.pp 2> /dev/null || :
done
/sbin/fixfiles -R %{modulename} restore || :
/sbin/restorecon -R /var/lib/awx/venv /var/lib/awx/job_status /var/run/memcached || :
chown -R memcached:memcached /var/run/memcached || :

%postun server
sed -i -e '/^# START AWX/,/^# END AWX/d' /etc/supervisord.conf
# Remove custom policy
if [ $1 -eq 0 ] ; then
    for selinuxvariant in %{selinux_variants} ; do
        /usr/sbin/semodule -s ${selinuxvariant} -r %{modulename} 2> /dev/null || :
    done
    # Remove sosreport symlinks
    rm -f %{distro_python_sitelib}/sos/plugins/tower.py || :
fi

%pre venv-ansible
getent group awx >/dev/null || groupadd -r awx
getent passwd awx >/dev/null || \
    useradd -r -g awx -d /var/lib/awx -s /bin/bash awx
virtualenv --system-site-packages /var/lib/awx/venv/ansible > /dev/null

%pre venv-tower
systemctl stop supervisord >/dev/null 2>&1 || :
getent group awx >/dev/null || groupadd -r awx
getent passwd awx >/dev/null || \
    useradd -r -g awx -d /var/lib/awx -s /bin/bash awx
virtualenv --clear --system-site-packages /var/lib/awx/venv/awx > /dev/null

%files
%defattr(-,root,root)

%files server
%exclude /var/lib/awx/setup
%exclude /var/lib/awx/venv
%defattr(-,root,root)
%doc %{_datadir}/doc/ansible-tower
%{_bindir}/awx-manage
%{_bindir}/awx-python
%{_bindir}/tower-manage
%{_bindir}/tower-python
%{_bindir}/ansible-tower-service
%{_bindir}/failure-event-handler
%attr(0750,memcached,memcached) /var/run/memcached
%dir %attr(0755,awx,awx) /var/lib/awx
%attr(0750,awx,awx) /var/log/tower
/var/lib/awx/[^j]*
%attr(0750,awx,awx) /var/lib/awx/job_status
%{_datadir}/selinux/*/%{modulename}.pp
%{_datadir}/awx/
%{_datadir}/sosreport/sos/plugins/tower.py*
%config(noreplace) %attr(-,root,awx) %{_sysconfdir}/tower
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}

%files ui
%defattr(-,root,root)
/var/lib/awx/venv/awx/lib/python2.7/site-packages/awx/static
/var/lib/awx/venv/awx/lib/python2.7/site-packages/awx/ui/static

%files setup
%defattr(-,root,root)
/var/lib/awx/setup
%{_bindir}/ansible-tower-setup

%files venv-ansible
%defattr(-,root,root)
/var/lib/awx/venv/ansible

%files venv-tower
%exclude /var/lib/awx/venv/awx/lib/python2.7/site-packages/awx/static
%exclude /var/lib/awx/venv/awx/lib/python2.7/site-packages/awx/ui/static
%defattr(-,root,root)
/var/lib/awx/venv/awx

%changelog
* Thu Jan 24 2019 Shane McDonald <shanemcd@redhat.com>
- 3.4.1 release

* Thu Jan 24 2019 Shane McDonald <shanemcd@redhat.com>
- 3.3.4 release

* Wed Jan 9 2019 Shane McDonald <shanemcd@redhat.com>
- 3.4.0 release

* Tue Dec 18 2018 Shane McDonald <shanemcd@redhat.com>
- 3.3.3 release

* Thu Dec 6 2018 Shane McDonald <shanemcd@redhat.com>
- 3.3.2 release

* Thu Oct 25 2018 Shane McDonald <shanemcd@redhat.com>
- 3.3.1 release

* Wed Sep 12 2018 Shane McDonald <shanemcd@redhat.com>
- 3.3.0 release

* Fri Aug 10 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.6 release

* Fri May 11 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.5 release

* Thu Apr 5 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.4 release

* Tue Feb 20 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.3 release

* Tue Feb 20 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.2 release

* Thu Dec 7 2017 Shane McDonald <shanemcd@redhat.com>
- 3.2.2 release

* Wed Oct 11 2017 Shane McDonald <shanemcd@redhat.com>
- 3.2.1 release

* Sun Oct 1 2017 Shane McDonald <shanemcd@redhat.com>
- 3.2.0 release

* Sun Sep 17 2017 Shane McDonald <shanemcd@redhat.com>
- 3.1.5 release

* Mon Jul 10 2017 Shane McDonald <shanemcd@redhat.com>
- 3.1.4 release

* Mon May 1 2017 Matthew Jones <matburt@redhat.com>
- 3.1.3 release

* Fri Apr 7 2017 Matthew Jones <matburt@redhat.com>
- 3.1.2-2 release

* Fri Mar 31 2017 Matthew Jones <matburt@redhat.com>
- 3.1.2 release

* Tue Mar 28 2017 Matthew Jones <matburt@redhat.com>
- 3.1.1 release

* Mon Feb 27 2017 Matthew Jones <matburt@redhat.com>
- 3.1.0 release

* Fri Oct 28 2016 Matthew Jones <matburt@redhat.com>
- 3.0.3 release

* Wed Aug 31 2016 Matthew Jones <matburt@redhat.com>
- 3.0.2 release

* Fri Jul 29 2016 Matthew Jones <matburt@redhat.com>
- 3.0.1 release

* Tue Jul 19 2016 Matthew Jones <matburt@redhat.com>
- 3.0.0 release

* Wed Apr 20 2016 Matthew Jones <matburt@redhat.com>
- 2.4.5 release

* Fri Feb 19 2016 Matthew Jones <matburt@redhat.com>
- 2.4.4 release

* Wed Dec 16 2015 Matthew Jones <mjones@ansible.com>
- 2.4.3 release

* Wed Dec 9 2015 Matthew Jones <mjones@ansible.com>
- 2.4.2 release

* Thu Nov 19 2015 Matthew Jones <mjones@ansible.com>
- 2.4.1 release

* Wed Nov 18 2015 Matthew Jones <mjones@ansible.com>
- 2.4.0 release

* Fri Oct 2 2015 Matthew Jones <mjones@ansible.com>
- 2.3.1 release

* Tue Sep 22 2015 Matthew Jones <mjones@ansible.com>
- 2.3.0 release

* Wed Aug 19 2015 Matthew Jones <mjones@ansible.com>
- 2.2.2 release

* Wed Aug 12 2015 Matthew Jones <mjones@ansible.com>
- 2.2.1 release

* Tue Jul 14 2015 Matthew Jones <mjones@ansible.com>
- 2.2.0 release

* Tue Jun 23 2015 Chris Meyers <cmeyers@ansible.com>
- 2.1.6 release

* Fri Jun 12 2015 Chris Meyers <cmeyers@ansible.com>
- 2.1.5 release

* Fri May 1 2015 Matthew Jones <mjones@ansible.com>
- 2.1.4 release

* Tue Apr 14 2015 Matthew Jones <mjones@ansible.com>
- 2.1.3 release

* Wed Mar 25 2015 Matthew Jones <mjones@ansible.com>
- 2.1.2 release

* Wed Feb 04 2015 Matthew Jones <mjones@ansible.com>
- 2.1.1 release

* Thu Jan 08 2015 Matthew Jones <mjones@ansible.com>
- 2.1.0 release

* Wed Dec 10 2014 Matthew Jones <mjones@ansible.com>
- 2.0.5 release

* Fri Nov 21 2014 James Laska <jlaska@ansible.com>
- 2.0.4 release

* Fri Nov 14 2014 James Laska <jlaska@ansible.com>
- 2.0.3 release

* Mon Oct 6 2014 James Laska <jlaska@ansible.com>
- 2.0.2 release

* Thu Sep 4 2014 James Laska <jlaska@ansible.com>
- 2.0.1 release

* Tue Aug 19 2014 James Laska <jlaska@ansible.com>
- 2.0.0 release

* Mon Jul 28 2014 James Laska <jlaska@ansible.com>
- 1.4.12 release

* Sun May 11 2014 James Laska <jlaska@ansible.com>
- 1.4.11 release

* Wed Apr 23 2014 James Laska <jlaska@ansible.com>
- 1.4.10 release

* Thu Apr 17 2014 James Laska <jlaska@ansible.com>
- 1.4.9 release

* Tue Apr 8 2014 James Laska <jlaska@ansible.com>
- 1.4.8 release

* Wed Jan 29 2014 James Laska <jlaska@ansible.com>
- 1.4.5 release

* Mon Jun 10 2013 James Cammarata <jimi@sngx.net>
- Initial RPM packaging for awx
